-----------------------------------------------------------
--|> Defaults
--: Defaults options
-----------------------------------------------------------
local _, NS = ...

--|> DEFAULT OPTIONS
-----------------------------------------------------------
NS._DefaultOptions = {}

--> Base Options
local Options = {
    DEBUG = false
}
--> Addon
---------------------------------------
Options.Addon = {
    Enabled = true,
    EnabledInBattlegrounds = true,
    EnabledInArena = false,
    Shown = true
}
--> Window
---------------------------------------
Options.Window = {
    Locked = false,
    Pinned = false,
    Collapsed = false,
    Visible = true
}
--> LDB
---------------------------------------
Options.LDB = {
    minimapPos = 200,
    minimap = true
}
--> Alerts
---------------------------------------
Options.Alerts = {
    PhasingChat = true
}
--> Audio Alerts
---------------------------------------
Options.AudioAlerts = {
    DetectedPlayerSound = true,
    DetectedPlayerSoundBGDisabled = false,
    DetectedPlayerSoundFile = "weizPVP: Notice 1"
}
--> Bars
---------------------------------------
Options.Bars = {
    MaxNumBars = 20,
    AlphaDead = 0.8,
    AlphaInactive = 0.6,
    AlphaDefault = 1,
    RowHeight = 20,
    VerticalSpacing = 1,
    Texture = "weizPVP: StatusBar",
    BarTexture = "weizPVP: Bar-BG",
    BarSolid = "weizPVP: SolidStatus",
    NameFont = "Accidental Presidency",
    NameFontSize = 16,
    LevelFont = "Accidental Presidency Italic",
    LevelFontSize = 16,
    GuildFont = "Accidental Presidency",
    GuildFontSize = 15
}
--> Sorting
---------------------------------------
Options.Sorting = {
    NearbyInactiveTimeout = 32,
    NearbyActiveTimeout = 20
}
--> Frames
---------------------------------------
Options.Frames = {
    BackgroundTexture = "weizPVP: #FFFFFF",
    BorderTexture = "weizPVP: Border",
    BackgroundColor = {
        0.02,
        0.02,
        0.02,
        0.5
    },
    Width = 251,
    Height = 247,
    X = 383,
    Y = -4.5,
    Scale = 1,
    AutoScaleEnabled = true,
    Point = "CENTER",
    BorderSize = 2,
    AutoResize = false,
    --> Scroll Frame
    Scroll = {
        Height = 0
    },
    --> List Frame
    List = {
        Height = 0
    },
    --> Header Frame
    Header = {
        Height = 20,
        BackgroundColor = {
            0.015,
            0.015,
            0.015,
            0.85
        },
        Font = "Roboto Condensed BoldItalic",
        FontSize = 17,
        X = 383,
        Y = 132,
        Scale = 1,
        Width = 251,
        FontOutline = "OUTLINE",
        Point = "CENTER"
    },
    --> Footer Frame
    Footer = {
        Height = 22,
        Font = "Accidental Presidency",
        FontSize = 16,
        FontOutline = "NONE",
        BackgroundColor = {
            0.01,
            0.01,
            0.01,
            0.6
        }
    }
}
--> Stealth Alert
---------------------------------------
Options.StealthAlert = {
    Enabled = true,
    EnableSound = true,
    SoundFile = "weizPVP: Warning 1"
}
--> KOS
---------------------------------------
Options.KOS = {
    AudioAlert = true,
    AudioAlertFile = "weizPVP: Warning 2",
    ChatAlert = true,
    TaskbarAlert = true
}
--> Crosshair
---------------------------------------
Options.Crosshair = {
    Enabled = true,
    Alpha = 1,
    Scale = 1,
    ShowBountyOverlay = false,
    NameEnabled = false,
    GuildEnabled = false,
    ShowRange = true,
    LineThickness = 1
}

--> Calculate additional sizes based on the dimensions of other elements
--: Dynamic values adjusted from other values needed during initial frame construction
-----------------------------------------------------------
Options.Frames.List.Height = Options.Bars.RowHeight + Options.Bars.VerticalSpacing
Options.Frames.Scroll.Height = (Options.Frames.List.Height * 12) + Options.Bars.VerticalSpacing -- hard code is hard mode
Options.Frames.Height = Options.Frames.Scroll.Height
Options.Frames.List.Height = Options.Frames.List.Height * Options.Bars.MaxNumBars

--> Apply Defaults
---------------------------------------
NS._DefaultOptions = {
    profile = {
        Options = Options,
        KosList = {}
    }
}
